

   MEMBER('Mmf.clw')                                       ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('MMF002.INC'),ONCE        !Local module procedure declarations
                     END


Host PROCEDURE                                             ! Generated from procedure template - Window


hFileMap             HANDLE
lpMapAddress         ULONG
Cstr                 CSTRING(51)
 
MapGroup             GROUP,PRE(MG)
Login       CString(51)  
Password1    CString(26)
SecLevel    Long 
                     END


QuickWindow          WINDOW('Window'),AT(,,181,81),FONT('MS Sans Serif',8,,FONT:regular),CENTER,IMM,HLP('Host'),TIMER(100),SYSTEM,GRAY,RESIZE
                       STRING('Login:'),AT(13,7),USE(?String1)
                       ENTRY(@s20),AT(79,7,83,10),USE(MapGroup.Login)
                       STRING('Password:'),AT(15,23),USE(?String2)
                       ENTRY(@s20),AT(79,23,83,10),USE(MapGroup.Password1)
                       STRING('Sec. Level:'),AT(17,40),USE(?String3)
                       ENTRY(@s20),AT(79,42,83,10),USE(MapGroup.SecLevel)
                       BUTTON('&OK'),AT(53,60,49,14),USE(?Ok),FLAT,LEFT,MSG('Accept operation'),TIP('Accept Operation'),ICON('WAOK.ICO'),STD(STD:Close)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It's called after the window open
!|
!---------------------------------------------------------------------------

CreateMMF Routine

   IF hFileMap = 0
      Cstr = 'PTSLOGINFO'
      hFileMap = CreateFileMappingA(0FFFFFFFFh, 0, PAGE_READWRITE, 0, 1024, ADDRESS(Cstr))
      IF hFileMap = 0
      END
   ! Map a view of the file mapped object
      lpMapAddress = MapViewOfFile(hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0)
      IF lpMapAddress = 0
      ELSE
      END
   END

OpenMMF Routine

   Cstr = 'PTSLOGINFO'
   hFileMap = OpenFileMappingA(FILE_MAP_ALL_ACCESS, FALSE, ADDRESS(Cstr))
   lpMapAddress = 0
   If hFileMap
      lpMapAddress = MapViewOfFile(hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0)
   END


ReadMMF Routine


   IF hFileMap = 0
   Else
      IF lpMapAddress = 0
      ELSE
         memcpy(ADDRESS(MapGroup), lpMapAddress, SIZE(MapGroup))
      END
   END

WriteMMF  Routine

      If  lpMapAddress <> 0
         memcpy(lpMapAddress, ADDRESS(MapGroup), SIZE(MapGroup))
      END

CloseMMF  Routine

   IF hFileMap = 0
   ELSE
      If lpMapAddress
         IF FlushViewOfFile(lpMapAddress, SIZE(MapGroup))
            IF UnmapViewOfFile(lpMapAddress)
               CloseHandle(hFileMap)
            ELSE
            END
         END
      END
   END





ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Host')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Ok,RequestCancelled)                    ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Ok,RequestCompleted)                    ! Add the close control to the window manger
  END
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('Host',QuickWindow)                         ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Host',QuickWindow)                      ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:CloseWindow
      Do CloseMMF
    OF EVENT:OpenWindow
      Do CreateMMF
    OF EVENT:Timer
      Do Writemmf
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults                                   ! Calculate default control parent-child relationships based upon their positions on the window

