   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
! C equates
SECTION_ALL_ACCESS      EQUATE(0f001fh)
SECTION_QUERY           EQUATE(0001h)
SECTION_MAP_WRITE       EQUATE(0002h)
SECTION_MAP_READ        EQUATE(0004h)
SECTION_MAP_EXECUTE     EQUATE(0008h)
SECTION_EXTEND_SIZE     EQUATE(0010h)
 
!PAGE_READWRITE          EQUATE(04h)
 
FILE_MAP_COPY           EQUATE(SECTION_QUERY)
FILE_MAP_WRITE          EQUATE(SECTION_MAP_WRITE)
FILE_MAP_READ           EQUATE(SECTION_MAP_READ)
FILE_MAP_ALL_ACCESS     EQUATE(SECTION_ALL_ACCESS)
 
BOOL                    EQUATE(SIGNED)
DWORD                   EQUATE(ULONG)
HANDLE                  EQUATE(UNSIGNED)
LPCSTR                  EQUATE(CSTRING)
LPSECURITY_ATTRIBUTES   EQUATE(ULONG)
LPVOID                  EQUATE(ULONG)

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('MMFBC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('MMF001.CLW')
Main                   PROCEDURE   !
     END
         MODULE('')
            CreateFileMappingA(HANDLE,LONG,DWORD,DWORD,DWORD,ULONG),HANDLE,PASCAL
            FlushViewOfFile(ULONG,DWORD),BOOL,PASCAL
            MapViewOfFile(HANDLE,DWORD,DWORD,DWORD,DWORD),ULONG,PASCAL
            OpenFileMappingA(DWORD,BOOL,ULONG),HANDLE,PASCAL
            UnmapViewOfFile(ULONG),BOOL,PASCAL
            memcpy(ULONG,ULONG,UNSIGNED),ULONG,PROC,NAME('_memcpy')
            strcmp(ULONG,ULONG),UNSIGNED,NAME('_strcmp')
         END
              MODULE('WIN')
                 CloseHandle(HANDLE),BOOL,PASCAL,PROC
              END
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'


PAGE_READWRITE          EQUATE(04h)

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

lCurrentFDSetting    LONG                                  ! Used by window frame dragging
lAdjFDSetting        LONG                                  ! ditto

  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('Mmf.INI', NVD_INI)                          ! Configure INIManager to use INI file
  DctInit
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)       ! Configure frame dragging
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

